#ifndef MANSTR_H
#define MANSTR_H

// for debugging
#ifdef MANSTRERR
	#define __MANSTRERR
#endif

#define str(mstr) (check(mstr) ? (mstr).src : "")
#define mstr(in) (createString(in, cstr_pstrlen(in)))
#define m(in) ((mstr_t) {in, cstr_pstrlen(in)})

/* various cstr functions */

extern int cstr_pstrlen(char* p_src); // returns the position of the null

extern void cstr_pstrcpyp(char** p_target, char* p_src);

/* managed strings */

typedef struct mstr_t {
	char* src;
	int len;
} mstr_t;

extern int check(mstr_t p_in);

extern mstr_t createStringU(char* p_src);
extern void clearString(mstr_t* p_str);
extern mstr_t createString(char* p_src, unsigned int nul_loc);

extern void appendString(mstr_t* p_target, mstr_t p_src);
extern mstr_t rappendString(mstr_t p_target, mstr_t p_src);

extern int compareString(mstr_t* p_target, mstr_t* p_src);
extern void copyString(mstr_t* p_target, mstr_t p_src);
extern void copyoString(mstr_t* p_target, mstr_t p_src, int b, int e);

extern void resizeString(mstr_t* p_target, int size);
extern void rrsizeString(mstr_t* p_target, int rsize);
extern void insertcString(mstr_t* p_target, char c, int i);

extern void delString(mstr_t* p_string, int b, int e);

extern void appendcString(mstr_t* p_target, char p_src);

void astrf(mstr_t* p_target, const char* fmt, ...);

extern void freeString(mstr_t* p_target);
#endif /* end of header guard */
